#include <stdlib.h>
#include <SDL2/SDL.h>

#define WINDOW_WIDTH 600



int root(int in){
	int out = in;
		while((out*out)>in){
			out--;
		}
	return out;

}

int midX(int x2,int x1){
    return ((x2+x1)/2);}
int midY(int y2,int y1){
    return ((y2+y1)/2);}

int pointSlopeForm (int y2, int y1, int x2, int x1){
    return (y2 - y1) / (x2 - x1);
}
    
 int distance (int y2, int y1, int x2, int x1){
    return root((x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1));}



int main(void) {
    SDL_Event event;
    SDL_Renderer *renderer;
    SDL_Window *window;

    int x = 300;
    int y = 300;


    int r = 200;

    int fidelity = 100;


    int a,b,c,m,mx,my,i;


       int lastx = x;
   int lasty = y + r;
    SDL_Init(SDL_INIT_VIDEO);
    SDL_CreateWindowAndRenderer(WINDOW_WIDTH, WINDOW_WIDTH, 0, &window, &renderer);
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 0);
    SDL_RenderClear(renderer);
    SDL_SetRenderDrawColor(renderer, 255, 255, 0, 255);
    //for (i = 0; i < WINDOW_WIDTH; ++i)
    //    SDL_RenderDrawPoint(renderer, i, i);

    for(int z=0;z<(fidelity/2);z++){
    	b = z*(r*2)/(fidelity);
    	c = r;
    	a = root((c*c)-(b*b));


        if(distance(lasty, y + a, lastx, x + b) > 1 ){
            SDL_SetRenderDrawColor(renderer, 255, 255, 255, 255);
            mx = midX(lastx, x + b);
            my = midY(lasty, y + a);
            m = pointSlopeForm(my, y, mx, x);
            i = 0;
            SDL_RenderDrawPoint(renderer,mx,my);
            while(distance(y, y + i * m, x, x + i) < r){
                i = i + 1;
                //
           }
         SDL_RenderDrawPoint(renderer, x+i, y+i*m);

            //SDL_RenderDrawPoint(renderer,mx,my);
        }
        SDL_SetRenderDrawColor(renderer, 255, 255, 0, 255);
    	SDL_RenderDrawPoint(renderer, x+b, y+a);
        SDL_RenderDrawPoint(renderer, x+b*-1, y+a);
        //SDL_RenderDrawPoint(renderer, x+b+5, y+a+5);

        lastx = x+b;
        lasty = y+a;
    	/*
    	SDL_RenderDrawPoint(renderer, x+b, y+a*-1);
    	SDL_RenderDrawPoint(renderer, x+b*-1, y+a*-1);*/

    }
    
    SDL_RenderDrawLine(renderer,10,10,10,20);

    SDL_RenderDrawLine(renderer,12,10,12,20);
    SDL_RenderPresent(renderer);
  return 0;
}